#include <iostream>
#include <vector>
#include "histogram.h"

using namespace std;

const int max_length = 80;  //  
const int indent = 4;       // 

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cout << "Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    cerr << "Enter numbers: " << endl;
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cerr << "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}

void show_histogram(const vector<double> bins, size_t bin_count){
double max_bin = bins[0];
    int k;
    for (size_t i = 0; i < bin_count; i++) {             //    bin[]
        if (bins[i] > max_bin) {
            max_bin = bins[i];
        }
    }
    if (max_bin <= (max_length - indent)) {           //    "*"     
        k = 0;
    }
    else {
        k = 1;
    }

    cerr << endl;
    int out;
    for (size_t i = 0; i < bin_count; i++) {
        cout.width(3);                                          // 
        cout.fill(' ');
        cout << bins[i] << "|";
        if (k == 0) {                                           // 
            out = bins[i];                                      //  
        }
        else {
            out = bins[i] * (max_length - indent) / max_bin;    //  
        }
        for (int j = 0; j < out; j++) {
            cout << "*";
        }
        cout << endl;
    }
}

int
main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram(bins, in.bin_count);
    return 0;
}
